/* mif_main.c */
void w_printf(Widget w, char *str);
void Find_Name_Widget(Widget *w, char *wname);
void UnmanageCb(Widget w, XtPointer client_data, XtPointer call_data);
void Load_Robots(Widget w, XtPointer client_data, XmFileSelectionBoxCallbackStruct *cbs);
void Load_Obstacles(Widget w, XtPointer client_data, XmFileSelectionBoxCallbackStruct *cbs);
void Save_Robots(Widget w, XtPointer client_data, XmFileSelectionBoxCallbackStruct *cbs);
void Save_Obstacles(Widget w, XtPointer client_data, XmFileSelectionBoxCallbackStruct *cbs);
void Load_Paths(Widget w, XtPointer client_data, XmFileSelectionBoxCallbackStruct *cbs);
void Save_Paths(Widget w, XtPointer client_data, XmFileSelectionBoxCallbackStruct *cbs);
void File(Widget w, int *file_type, XtPointer call_data);
void Init_Timeout_Procedure(void);
void Show_Holo_Path(Widget w, int *file_type, XtPointer call_data);
void Show_NHolo_Path(Widget w, int *file_type, XtPointer call_data);
void Animate_Holo_Path(Widget w, XtPointer dummy, XtPointer call_data);
void Animate_NHolo_Path(Widget w, XtPointer dummy, XtPointer call_data);
void Animate(timeout_data *to);
void Reset(Widget w, XtPointer client_data, XtPointer call_data);
void Refresh(Widget w, XtPointer client_data, XtPointer call_data);
void Quit(Widget w, XtPointer client_data, XtPointer call_data);
void Verbosity_Set(Widget w, int *v, XtPointer call_data);
void Debug(Widget w, int *v, XtPointer call_data);
void Change_Animate_Speed(Widget w, XtPointer client_data, XtPointer call_data);
void Really_Quit(Widget w, XtPointer client_data, XtPointer call_data);
void Plan_Holo(Widget w, XtPointer client_data, XtPointer call_data);
void Plan_NHolo(Widget w, XtPointer client_data, XtPointer call_data);
void Optimize_NHolo_Path(Widget w, XtPointer client_data, XtPointer call_data);
void Init_Robots(char *robot_filename);
void Init_Obstacles(char *obst_filename);
void Init_Paths(char *path_filename);
void Init_Widget(void);
int main(int argc, char **argv);
/* mif_gfx.c */
void Checkout_Temp_Ipolygon(Ipolygon *poly);
void Checkin_Temp_Ipolygon(void);
void Checkout_Temp_Fpolygon(Fpolygon *poly);
void Checkin_Temp_Fpolygon(void);
void Conf_C2P(Fq p1, Fq *p2);
void FPoint_C2P(Fpoint p1, Fpoint *p2);
void FIPoint_C2P(Fpoint p1, Ipoint *p2);
void IPoint_C2P(Ipoint p1, Ipoint *p2);
void FPoint_P2C(Fpoint p1, Fpoint *p2);
void IPoint_P2C(Ipoint p1, Ipoint *p2);
void FIPoint_P2C(Fpoint p1, Ipoint *p2);
void Init_Drag_Timeout(void);
void Start_Rotation(int cc);
void Stop_Timeout(timeout_data *to);
void Start_Timeout(timeout_data *to);
int Close_Enough(Ipoint mouse, Ipoint orig, int *dist);
void Track_Translation(timeout_data *to);
void Track_Rotation(int sign);
void Start_Tracking(Widget canvas, XtPointer client_data, XEvent *event);
void End_Tracking(Widget canvas, XtPointer client_data, XEvent *event);
void Hook_Tracker_Handlers(Widget w);
void Draw_Outlined_Filled_Polygon(Drawable d, Ipolygon *poly, int outline_c, int fill_c);
void Draw_Outlined_Polygon(Drawable d, Ipolygon *poly, int outline_c);
void Draw_Filled_Polygon(Drawable d, Ipolygon *poly, int fill_c);
unsigned long Get_Pixel(char *color_name);
void Init_Canvas(Widget w);
void Convert_P2C_Polygon(Fpolygon poly1, Ipolygon *poly2);
void Transform_Planner_Polygon(Fpoint orig, float theta, Fpolygon p1, Fpolygon *p2);
void Update_Planner_Robots_Conf(robot_data *robots);
void Update_Canvas_Obj_Polygon(canvas_obj *obj);
void Update_Canvas_Robots_Conf(robot_data *robots);
void Update_Canvas_Obst_Conf(obst_data *obsts);
void Update_Planner_One_Obst_Conf(obst_data *obst);
void Update_Planner_Obst_Conf(obst_data *obsts);
void Display_Obstacles(void);
void Display_One_Robot(int npoly, Ipolygon *poly, int oc, int fc, int flush);
void Display_One_Robot_On_Screen(int npoly, Ipolygon *poly, int oc, int fc, int flush);
void Display_One_Robot_On_Buffer(int npoly, Ipolygon *poly, int oc, int fc, int flush);
void Display_Robots(void);
void Get_Path_Step_Polygon(Fq q, robot_data *robot, Ipolygon *ipoly);
void Display_Path_Step(Fq q, robot_data *robot, int c);
void Display_Robots_Path_Step_On_Buffer(int path_idx, path_type ptype);
void Display_Robots_Path_Step(int path_idx, path_type ptype);
void Draw_Workspace_Boundary(int thickness);
void Refresh_Environment(void);
void Display_Environment_WO_Flush(void);
void Display_Environment(void);
void Init_Canvas_Objects(void);
void Init_Scale(void);
void Init_Graphics(void);
/* mif_plan.c */
void Check_Path_Memory(objpath *cpath, int len);
void Interpolate_Conf(Fq A, Fq B, int interval, Fq *st);
void Print_Fpolygons(int npoly, Fpolygon *poly);
void Print_All_Polygons(planner_obj *robot, int nobst, planner_obj **obsts);
int Holo_Plan(int dx, int dy, planner_obj *robot, int nobst, planner_obj **obstacle, objpath *holo_path);
int NHolo_Plan(int dx, int dy, planner_obj *robot, int nobst, planner_obj **obstacle, objpath *nholo_path);
int Optimize(int dx, int dy, planner_obj *robot, int nobst, planner_obj **obstacle, objpath *nholo_path);
void Smooth1(objpath *pX);
/* mif_init.c */
void NO_MORE_MEMORY(char *calling_routine);
obst_data *Allocate_Obstacle(int nobst);
robot_data *Allocate_Robot(int nrobot);
Fpolygon *Allocate_Fpolygon(int npoly);
Ipolygon *Allocate_Ipolygon(int npoly);
Ipoint *Allocate_Ivert(int nvert);
Fpoint *Allocate_Fvert(int nvert);
void Read_Robots(char *filename, int *nrobot, robot_data **robots);
void Read_Obstacles(char *filename, int *nobst, obst_data **obst);
void Write_Robots(char *filename, int nrobots, robot_data *robot);
void Write_Obstacles(char *filename, int nobsts, obst_data *obst);
void Read_Paths(char *name, int nrobots, robot_data *robots);
void Write_Paths(char *name, int nrobots, robot_data *robots);
void Init_Planner(int dx, int dy, int dth);
